 /*
  * Khoros: $Id: vcast.h,v 1.1 1991/05/10 15:46:57 khoros Exp $
  */

 /*
  * $Log: vcast.h,v $
 * Revision 1.1  1991/05/10  15:46:57  khoros
 * Initial revision
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: vcast.h
 >>>>            Author: Charlie Gage
 >>>> Date Last Updated: Tue Mar  5 22:23:15 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _vcast_h_
#define _vcast_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program,	/* a pointer to the program name argv[0] */
	*calloc();
int	ac;

/****************************************************************
*
*                    vcast Argument Structure
*
****************************************************************/

typedef struct _vcast  {

/*
 *  input image #1 (Required infile)
 */
char	*i1_file;	/* input image #1 FILENAME */
int	 i1_flag;	/* input image #1 FLAG */

/*
 *  input image #2 (Required infile)
 */
char	*i2_file;	/* input image #2 FILENAME */
int	 i2_flag;	/* input image #2 FLAG */

/*
 *  output image #1 (Required outfile)
 */
char	*o1_file;	/* output image #1 FILENAME */
int	 o1_flag;	/* output image #1 FLAG */

/*
 *  output image #2 (Required outfile)
 */
char	*o2_file;	/* output image #2 FILENAME */
int	 o2_flag;	/* output image #2 FLAG */

/*
 *  input image #3 (Optional infile)
 */
char	*i3_file;	/* input image #3 FILENAME */
int	 i3_flag;	/* input image #3 FLAG */

/*
 *  input image #4 (Optional infile)
 */
char	*i4_file;	/* input image #4 FILENAME */
int	 i4_flag;	/* input image #4 FLAG */

/*
 *  input image #5 (Optional infile)
 */
char	*i5_file;	/* input image #5 FILENAME */
int	 i5_flag;	/* input image #5 FLAG */

/*
 *  output image #3 (Optional outfile)
 */
char	*o3_file;	/* output image #3 FILENAME */
int	 o3_flag;	/* output image #3 FLAG */

/*
 *  output image #4 (Optional outfile)
 */
char	*o4_file;	/* output image #4 FILENAME */
int	 o4_flag;	/* output image #4 FLAG */

/*
 *  output image #5 (Optional outfile)
 */
char	*o5_file;	/* output image #5 FILENAME */
int	 o5_flag;	/* output image #5 FLAG */

/*
 * Select data type [default = Auto Upcast to Highest Input Data Type] (Optional string toggle - )
 */
char	*t_toggle;		/* Select data type [default = Auto Upcast to Highest Input Data Type] STRING TOGGLE */
int	 t_flag;		/* Select data type [default = Auto Upcast to Highest Input Data Type] FLAG */

}  vcast_struct;

vcast_struct *vcast;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */
#define MATCHINPUT(program, img1, img2) \
        (void) match_num_images(program,img1,img2,TRUE)
/* -include_macros_end */

#endif
