 /*
  * Khoros: $Id: putimage.h,v 1.3 1992/03/20 22:40:25 dkhoros Exp $
  */

 /*
  * $Log: putimage.h,v $
 * Revision 1.3  1992/03/20  22:40:25  dkhoros
 * VirtualPatch5
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: putimage.h
 >>>>            Author: Stephanie Hallett and Mark Young
 >>>> Date Last Updated: Tue Feb 11 22:33:56 1992
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _putimage_h_
#define _putimage_h_

#include "xvinclude.h"


/* -include_includes */
#include "xvforms.h"
#include "xvdisplay.h"
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    putimage Argument Structure
*
****************************************************************/

typedef struct _putimage  {

/*
 *  input image filename (Required infile)
 */
char	*i;     	/* input image filename FILENAME */
int	 i_flag;	/* input image filename FLAG */

/*
 *  overlay image filename (Optional infile)
 */
char	*ov;     	/* overlay image filename FILENAME */
int	 ov_flag;	/* overlay image filename FLAG */

/*
 *  shape mask filename (Optional infile)
 */
char	*s;     	/* shape mask filename FILENAME */
int	 s_flag;	/* shape mask filename FLAG */

/*
 *  clip mask filename (Optional infile)
 */
char	*c;     	/* clip mask filename FILENAME */
int	 c_flag;	/* clip mask filename FLAG */

/*
 *  image with alternate colormap filename (Optional infile)
 */
char	*cmap_image;     	/* image with alternate colormap filename FILENAME */
int	 cmap_image_flag;	/* image with alternate colormap filename FLAG */

/*
 *  x value of upper-left corner of image (Optional integer)
 */
int	 x;    	/* x value of upper-left corner of image INT */
int	 x_flag;	/* x value of upper-left corner of image FLAG */

/*
 *  y value of upper-left corner of image (Optional integer)
 */
int	 y;    	/* y value of upper-left corner of image INT */
int	 y_flag;	/* y value of upper-left corner of image FLAG */

/*
 *  update time (Optional float)
 */
float	 update;      	/* update time FLOAT */
int	 update_flag;   	/* update time FLAG */

/*
 *  host:display.screen (Optional string)
 */
char	*display;       	/* host:display.screen STRING */
int	 display_flag;   	/* host:display.screen FLAG */

/*
 *  use colormap? (Optional logical)
 */
int	 use_cmap;      	/* use colormap? LOGIC */
int	 use_cmap_flag;  	/* use colormap? FLAG */

}  putimage_struct;

putimage_struct *putimage;

/* -include_additions */
int      PUTIMAGE_DONE;
/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
